package org.ajax4jsf.bean;

import java.util.ArrayList;
import java.util.List;

public class IndexBean {
	
	private List<ComponentItem> list = new ArrayList<ComponentItem>();
	
	public class ComponentItem {
		String name;
		String link;
		
		
		public ComponentItem(String name, String link) {
			this.name = name;
			this.link = link;
		}

		/**
		 * @return the name
		 */
		public String getName() {
			return name;
		}

		/**
		 * @return the link
		 */
		public String getLink() {
			return link;
		}
		
		/* (non-Javadoc)
		 * @see java.lang.Object#equals(java.lang.Object)
		 */
		@Override
		public boolean equals(Object obj) {
			if (!(obj instanceof ComponentItem)) {
				return false;
			}
			
			if (obj == null) {
				return true;
			}
			return name.equals(((ComponentItem)obj).name);
		}
		
	};
	
	public IndexBean() {
		list.add(new ComponentItem("<a4j:commandButton>", "ajaxCommandButton/ajaxButtonTest.xhtml"));
		list.add(new ComponentItem("<a4j:commandLink>", "ajaxCommandLink/ajaxLinkTest.xhtml"));
		list.add(new ComponentItem("<a4j:poll>", "ajaxPoll/ajaxPollTest.xhtml"));
		list.add(new ComponentItem("<a4j:region>", "ajaxRegion/ajaxRegionTest.xhtml"));
		list.add(new ComponentItem("<rich:calendar>", "ajaxStatus/ajaxStatusTest.xhtml"));
		list.add(new ComponentItem("<rich:combobox>", "calendar/calendarTest.xhtml"));
		list.add(new ComponentItem("<rich:contextMenu>", "comboBox/comboBoxTest.xhtml"));
		list.add(new ComponentItem("<rich:dataTable>", "contextMenu/contextMenu.xhtml"));
		list.add(new ComponentItem("<rich:dropDownMenu>", "dataTable/dataTableTest.xhtml"));
		list.add(new ComponentItem("<rich:inplaceSelect>", "inplaceSelect/inplaceSelectTest.xhtml"));
		list.add(new ComponentItem("<rich:inputNumberSpinner>", "inputNumberSpinner/inputNumberSpinnerTest.xhtml"));
		list.add(new ComponentItem("<rich:jsFunction>", "jsFunction/jsFunctionTest.xhtml"));
		list.add(new ComponentItem("<a4j:keepAlive>", "keepAlive/keepAliveTest.xhtml"));
		list.add(new ComponentItem("<a4j:loadScript>", "loadScript/loadScriptTest.xhtml"));
		list.add(new ComponentItem("<a4j:loadStyle>", "loadStyle/loadStyleTest.xhtml"));
		list.add(new ComponentItem("<rich:orderingList>", "orderingList/orderingListTest.xhtml"));
		list.add(new ComponentItem("<rich:panelBar>", "panelBar/panelBarTest.xhtml"));
		list.add(new ComponentItem("<rich:panelMenu>", "panelMenu/panelMenuTest.xhtml"));
		list.add(new ComponentItem("<rich:pickList>", "pickList/pickListTest.xhtml"));
		list.add(new ComponentItem("<rich:progressBar>", "progressBar/progressBarTest.xhtml"));
		list.add(new ComponentItem("<rich:simpleTogglePanel>", "simpleTogglePanel/simpleTogglePanel.xhtml"));
		list.add(new ComponentItem("<rich:tabPanel>", "tabPanel/tabPanelTest.xhtml"));
		list.add(new ComponentItem("<rich:togglePanel>", "togglePanel/togglePanelTest.xhtml"));
		
		}
	
	/**
	 * @return the list
	 */
	public List<ComponentItem> getList() {
		return list;
	}


}
