package org.richfaces.testng;

import static org.testng.Assert.assertEquals;

import org.richfaces.RichSeleniumTest;
import org.richfaces.SeleniumTestBase;
import org.richfaces.Templates;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Parameters;
import org.testng.annotations.Test;

public class LoadScriptTest extends SeleniumTestBase implements RichSeleniumTest {

    public LoadScriptTest() {
        super("http", "localhost", serverPort);
    }

    /**
     * This method are invoking before selenium tests started
     */
    @BeforeTest
    @Parameters( { "browser" })
    public void startSelenium(String browser) {
        super.startSelenium(browser);
    }

    /**
     * This method are invoking after selenium tests completed
     */
    @AfterTest
    public void stopSelenium() {
        super.stopSelenium();
    }

    @Test
    public void testLoadScriptComponent() throws Exception {
    	_testLoadScriptComponent(Templates.SIMPLE);
        _testLoadScriptComponent(Templates.DATATABLE);
        _testLoadScriptComponent(Templates.MODALPANEL);
    }

    private void _testLoadScriptComponent(Templates template) {
        renderPage(getTestUrl(), template);
        String jsCall = "summarize(%1$s, %2$s);";
        int opr1 = 1;
        int opr2 = 2;
        String result = runScript(String.format(jsCall, opr1, opr2));
        assertEquals(Integer.parseInt(result), opr1 + opr2);
    }

	public String getTestUrl() {
		return "/faces/pages/loadScript/loadScriptTest.xhtml";
	}
}
