package org.richfaces.testng;


import static org.testng.Assert.assertEquals;

import org.richfaces.RichSeleniumTest;
import org.richfaces.SeleniumTestBase;
import org.richfaces.Templates;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Parameters;
import org.testng.annotations.Test;

public class LoadStyleTest extends SeleniumTestBase implements RichSeleniumTest {

    public LoadStyleTest() {
        super("http", "localhost", serverPort);
    }

    /**
     * This method are invoking before selenium tests started
     */
    @BeforeTest
    @Parameters( { "browser" })
    public void startSelenium(String browser) {
        super.startSelenium(browser);
    }

    /**
     * This method are invoking after selenium tests completed
     */
    @AfterTest
    public void stopSelenium() {
        super.stopSelenium();
    }

    @Test
    public void testLoadStyleComponent() throws Exception {
    	_testLoadStyleComponent(Templates.SIMPLE);
        _testLoadStyleComponent(Templates.DATATABLE);
        _testLoadStyleComponent(Templates.MODALPANEL);
    }

    private void _testLoadStyleComponent(Templates template) {
        renderPage(getTestUrl(), template);
        String divId = getParentId() + "rectangle";
        assertEquals(50, getWidthById(divId));
        assertEquals(100, getHeightById(divId));
    }

	public String getTestUrl() {
		return "/faces/pages/loadStyle/loadStyleTest.xhtml";
	}
}
